// Generated by CoffeeScript 1.10.0
(function() {
  var EntityDescription, MigrationDescription;

  EntityDescription = require('../Descriptors/EntityDescription');

  MigrationDescription = (function() {
    function MigrationDescription(modelFrom, modelTo) {
      this.modelFrom = modelFrom;
      this.modelTo = modelTo;
      this.entitiesChanges = [];
      this.attributesChanges = {};
      this.relationshipsChanges = {};
      this.scriptsBefore = [];
      this.scriptsAfter = [];
    }

    MigrationDescription.prototype.addEntity = function(name) {
      return this.entitiesChanges.push({
        entity: this._entityName(name),
        change: '+'
      });
    };

    MigrationDescription.prototype.renameEntity = function(oldName, newName) {
      return this.entitiesChanges.push({
        entity: this._entityName(oldName),
        change: this._entityName(newName)
      });
    };

    MigrationDescription.prototype.removeEntity = function(name) {
      return this.entitiesChanges.push({
        entity: this._entityName(name),
        change: '-'
      });
    };

    MigrationDescription.prototype._entityName = function(entity) {
      if (entity instanceof EntityDescription) {
        return entity.name;
      }
      return entity;
    };

    MigrationDescription.prototype.addAttribute = function(entity, name) {
      var entityName;
      entityName = this._entityName(entity);
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][name] = '+';
    };

    MigrationDescription.prototype.renameAttribute = function(entity, name, newName) {
      var entityName;
      entityName = this._entityName(entity);
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][name] = newName;
    };

    MigrationDescription.prototype.removeAttribute = function(entity, name) {
      var entityName;
      entityName = this._entityName(entity);
      this.attributesChanges[entityName] = this.attributesChanges[entityName] || {};
      return this.attributesChanges[entityName][name] = '-';
    };

    MigrationDescription.prototype.addRelationship = function(entity, name) {
      var entityName;
      entityName = this._entityName(entity);
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][name] = '+';
    };

    MigrationDescription.prototype.renameRelationship = function(entity, name, newName) {
      var entityName;
      entityName = this._entityName(entity);
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][name] = newName;
    };

    MigrationDescription.prototype.removeRelationship = function(entity, name) {
      var entityName;
      entityName = this._entityName(entity);
      this.relationshipsChanges[entityName] = this.relationshipsChanges[entityName] || {};
      return this.relationshipsChanges[entityName][name] = '-';
    };

    MigrationDescription.prototype.addScriptBefore = function(script, name) {
      return this.scriptsBefore.push({
        script: script,
        name: name
      });
    };

    MigrationDescription.prototype.addScriptAfter = function(script, name) {
      return this.scriptsAfter.push({
        script: script,
        name: name
      });
    };

    return MigrationDescription;

  })();

  module.exports = MigrationDescription;

}).call(this);
